CCTracker = CreateFrame("Frame");

local RaidIconMaskToIndex = {
	[COMBATLOG_OBJECT_RAIDTARGET1] = 1,
	[COMBATLOG_OBJECT_RAIDTARGET2] = 2,
	[COMBATLOG_OBJECT_RAIDTARGET3] = 3,
	[COMBATLOG_OBJECT_RAIDTARGET4] = 4,
	[COMBATLOG_OBJECT_RAIDTARGET5] = 5,
	[COMBATLOG_OBJECT_RAIDTARGET6] = 6,
	[COMBATLOG_OBJECT_RAIDTARGET7] = 7,
	[COMBATLOG_OBJECT_RAIDTARGET8] = 8
};

local currentCC = {};
local ccSpells = {};

local currentTick = "";
local tickDamage = {};
local tickCCBreak = {};

--rogue
ccSpells["Sap"]="any";
ccSpells["Blind"]="any";
ccSpells["Gouge"]="notMyBleeds";

--shamen
ccSpells["Hex"]="damage";
ccSpells["Bind Elemental"]="any";

--pally
ccSpells["Repentance"]="notMyBleeds";

--hunter
ccSpells["Scatter Shot"]="any";
ccSpells["Freezing Trap"]="any";
ccSpells["Wyvern Sting"]="any";

--warrior
ccSpells["Intimidating Shout"]="any";

--dk
ccSpells["Hungering Cold"]="notMyBleeds";

--mage
ccSpells["Polymorph"]="any";
ccSpells["Ring of Frost"]="any";

--priest
ccSpells["Psychic Scream"]="damage";

--warlock
ccSpells["Fear"]="damage";
ccSpells["Howl of Terror"]="damage";

--druid
ccSpells["Entangling Roots"]="notMyBleeds";
			
local DEBUG = false;
local CUR_VER = 1;

if CCTrackerSettings ~= nil and CCTrackerSettings["ver"] > 1 then
	CCTrackerSettings = nil;
end

if CCTrackerSettings == nil then
	CCTrackerSettings = {}
	CCTrackerSettings["ver"] = 1;
	CCTrackerSettings["channel"] = "SELF";
end

CCTracker:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatLog")

CCTracker:SetScript("OnEvent", function(self, event, ...)
    if (event=="COMBAT_LOG_EVENT_UNFILTERED") then
        CCTracker:CombatLog(event,...)
    end
end)

function CCTracker:ccDamage(sourceName,spellID,destGUID,destName,destFlags,destFlags2)
	print("cc damaged | " .. destGUID .. " | " .. spellID);
	if (tickCCBreak[destGUID] ~= nil)
	then
		for k,v in pairs(tickCCBreak[destGUID]) do
			CCTracker:ccBreak(sourceName,k,nil,destGUID,destName,destFlags,destFlags2,spellID,nil);
		end
	else
		tickDamage[destGUID] = {}
		tickDamage[destGUID]["sourceName"]=sourceName;
		tickDamage[destGUID]["spellID"]=spellID;
	end
end

function CCTracker:ccBreak(sourceName,spellID,spellName,destGUID,destName,destFlags,destFlags2,otherSpellID,otherSpellName)
	print("cc broken | " .. destGUID .. " | " .. spellID);
	local spellLink, craftingLink, otherSpellLink, otherCraftingLink, raidIconIndex
	
	if (destGUID ~= nil)
	then
		currentCC[destGUID][spellID] = nil;
		raidIconIndex = RaidIconMaskToIndex[bit.band(destFlags2, COMBATLOG_OBJECT_RAIDTARGET_MASK)];
	else
		raidIconIndex = nil;
	end
	
	if (spellID == -1)
	then
		if (raidIconIndex ~= nil)
		then
			CCTracker:Output(spellLink.." was broken on {rt".. raidIconIndex .."}"..destName.." by environmental damage");
		else
			CCTracker:Output(spellLink.." was broken on "..destName.." by environmental damage");
		end
	elseif (spellID ~= nil)
	then
		spellLink, craftingLink = GetSpellLink(spellID);
		otherSpellLink, otherCraftingLink = GetSpellLink(otherSpellID);
	else -- for /cc test <cc breaker> <cc'd target> <cc spell> <breaking spell>
		spellLink = spellName;
		otherSpellLink = otherSpellName;
	end
			
	if (raidIconIndex ~= nil)
	then
		CCTracker:Output(sourceName.." broke "..spellLink.." on {rt".. raidIconIndex .."}"..destName.." with "..otherSpellLink);
	else
		CCTracker:Output(sourceName.." broke "..spellLink.." on "..destName.." with "..otherSpellLink);
	end
end

function CCTracker:ccRemoved(spellID,destGUID,destName,destFlags,destFlags2)
	print("cc removed | " .. destGUID .. " | " .. spellID);
	if (tickDamage ~= nil and tickDamage[destGUID] ~= nil)
	then
		CCTracker:ccBreak(tickDamage[destGUID]["sourceName"],spellID,nil,destGUID,destName,destFlags,destFlags2,tickDamage[destGUID]["spellID"],nil);
	else
		if (tickCCBreak[destGUID] == nil)
		then
			tickCCBreak[destGUID] = {};
		end
		tickCCBreak[destGUID][spellID] = {};
		tickCCBreak[destGUID][spellID]["destName"]=destName;
	end
end

function CCTracker:ccApply(spellID,spellName,sourceGUID,sourceName,destGUID)
	print("cc applied | " .. destGUID .. " | " .. spellID);
	if (currentCC[destGUID] == nil)
	then
		currentCC[destGUID] = {}
	end
	currentCC[destGUID][spellID] = {};
	currentCC[destGUID][spellID]["srcGUID"]=sourceGUID;
	currentCC[destGUID][spellID]["srcName"]=srcName;
end

function CCTracker:CombatLog(event,...)
    local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2, spellID, spellName, something, otherSpellID, otherSpellName = ...
	
	if (currentTick ~= timestamp)
	then
		if (tickCCBreak[destGUID] ~= nil) --must have expired naturally
		then
			for k,v in pairs(tickCCBreak[destGUID]) do
				if (currentCC[destGUID] ~= nil)
				then
					currentCC[destGUID][k] = nil;
				end
				if (currentCC[destGUID] == {})
				then
					currentCC[destGUID] = nil;
				end
			end
		end
		tickCCBreak = {}
		tickDamage = {};
		currentTick = timestamp;
	end
	
	if (destName ~= nil and UnitIsFriend("player",destName) ~= nil)
	then
		return;
	end
	
	if DEBUG then
		print(timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2, spellID, spellName, something, otherSpellID, otherSpellName);
	end
	
	if (type=="SWING_DAMAGE" and currentCC[destGUID] ~= nil)
	then
		CCTracker:ccDamage(sourceName,6603,destGUID,destName,destFlags,destFlags2); --AutoAttack
	elseif ((type=="SPELL_DAMAGE" or type=="RANGE_DAMAGE" or type=="SPELL_PERIODIC_DAMAGE" or type=="SPELL_BUILDING_DAMAGE") and currentCC[destGUID] ~= nil)
	then
		CCTracker:ccDamage(sourceName,spellID,destGUID,destName,destFlags,destFlags2);
	elseif (type=="ENVIRONMENTAL_DAMAGE" and currentCC[destGUID] ~= nil)
	then
		CCTracker:ccDamage(sourceName,-1,destGUID,destName,destFlags,destFlags2);
	elseif (type=="SPELL_AURA_APPLIED" or type =="SPELL_AURA_REFRESH")
	then
		for k,v in pairs(ccSpells) do
			if (spellName == k)  then
				CCTracker:ccApply(spellID,spellName,sourceGUID,sourceName,destGUID);
			end
		end
	elseif (type=="SPELL_AURA_REMOVED")
	then
		for k,v in pairs(ccSpells) do
			if (currentCC[destGUID] ~= nil and spellName == k)
			then
				CCTracker:ccRemoved(spellID,destGUID,destName,destFlags,destFlags2);
			end
		end
	elseif (type=="SPELL_AURA_BROKEN_SPELL")
	then
		CCTracker:ccBreak(sourceName,spellID,spellName,destGUID,destName,destFlags,destFlags2,otherSpellID,otherSpellName);
	end
	
	for gui,guiData in pairs(currentCC) do
		keepTarget = false;
		for cc, ccData in pairs(currentCC[gui]) do
			if ccData ~= nil
			then
				keepTarget = true;
			end
		end
		if keepTarget == false
		then
			currentCC[gui] = nil;
		end
	end
end

function CCTracker:Output(msg)
	if CCTrackerSettings["channel"] == "SELF" then
		DEFAULT_CHAT_FRAME:AddMessage(msg);
	else
		SendChatMessage(msg,CCTrackerSettings["channel"],nil,nil);
	end
end

SLASH_CCTRACKER1 = "/cc"
SlashCmdList["CCTRACKER"] = function(msg)
	local cmd = CCTracker:split(msg:lower(), " ");

	if cmd[1] == "test" then
		CCTracker:CombatLog(nil,nil,"SPELL_AURA_BROKEN_SPELL",false,nil,cmd[2],nil,nil,cmd[3],nil,nil,cmd[4],nil,nil,cmd[5]);
	elseif cmd[1] == "debug" then
		if cmd[2] == "on" then
			print("Debuging enabled");
			DEBUG = true;
		else
			print("Debuging disabled");
			DEBUG = false;
		end
	elseif cmd[1] == "channel" then
		if cmd[2] == "" or cmd[2] == "self" then
			cmd[2] = "SELF";
		end
		CCTrackerSettings["channel"] = cmd[2];
	end
end

--http://wow.mmoui.com/forums/showthread.php?p=232488
local function GetIconIndex(flags)
    local number, mask, mark
    if bit.band(flags, COMBATLOG_OBJECT_SPECIAL_MASK) ~= 0 then
        for i=1,8 do
            mask = COMBATLOG_OBJECT_RAIDTARGET1 * (2 ^ (i - 1))
            mark = bit.band(flags, mask) == mask
            if mark then number = i break end
        end
    end
    return number
end

--http://lua-users.org/wiki/SplitJoin THX!
function CCTracker:split(str, pat)
   local t = {}  -- NOTE: use {n = 0} in Lua-5.0
   local fpat = "(.-)" .. pat
   local last_end = 1
   local s, e, cap = str:find(fpat, 1)
   while s do
      if s ~= 1 or cap ~= "" then
	 table.insert(t,cap)
      end
      last_end = e+1
      s, e, cap = str:find(fpat, last_end)
   end
   if last_end <= #str then
      cap = str:sub(last_end)
      table.insert(t, cap)
   end
   return t
end